package de.micka.lebenshilfe;

import java.util.Calendar;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.DatePicker.OnDateChangedListener;

public class EintragAendernActivity extends Activity implements  OnDateChangedListener
{
	
	private final static String MY_DB_NAME = "HaushaltsbuchDB";
	private static String MY_DB_TABLE = "eintraege";
	public static String GUTHABEN = "guthaben";
	public static String TABELLENNAME = "tabellenname";
	public static String TABELLENTYP = "tabellentyp";
	private String listenname;
	private String tabellentyp;
	private final static String tag="ensacom"; 
	private long id;
	private SQLiteDatabase myDB = null;
	private Eintrag eintrag;
	DatePicker datePicker;
	private Calendar c = Calendar.getInstance();
	public void onCreate(Bundle savedInstanceState) 
	{
        super.onCreate(savedInstanceState);
        setContentView(R.layout.eintragaendernlayout);
        datePicker = (DatePicker) findViewById(R.id.datePicker_aendern);
        altenEintragLaden();
    }
	@Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            Intent i = new Intent(this, Tabellenuebersicht.class);;
            finish();
            startActivity(i);
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
	public void altenEintragLaden()
	{
		myDB = null;
	    final Bundle extras = getIntent().getExtras();
	    if(extras != null)
	    {
	    	listenname = extras.getString(Tabellenansicht.TABELLENNAME);
	    	this.id = extras.getLong(Tabellenansicht.ID);
	    	tabellentyp = extras.getString(Tabellenansicht.TABELLENTYP);
	    }
	    eintrag = null;
	    myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
	    Cursor eintragCursor = myDB.rawQuery("SELECT _id, day, month,  year, wofuer, betrag, listenname, listentyp FROM " + MY_DB_TABLE + " WHERE _id=" + id , null);
	    eintragCursor.moveToFirst();
	   	if(eintragCursor.moveToFirst())
		{
	   		//							  _id					day						dayid					month					monthid						year					yearid						wofuer					betrag
			//eintrag = new Eintrag(eintragCursor.getInt(0),eintragCursor.getInt(1),eintragCursor.getInt(2),eintragCursor.getInt(3), eintragCursor.getInt(4), eintragCursor.getInt(5), eintragCursor.getInt(6), eintragCursor.getString(7),eintragCursor.getDouble(8));
			//								id							day					month				year					wofuer					betrag
			eintrag = new Eintrag(eintragCursor.getInt(0),eintragCursor.getInt(1),eintragCursor.getInt(2),eintragCursor.getInt(3),eintragCursor.getString(4),eintragCursor.getDouble(5));
			listenname = eintragCursor.getString(6);
			tabellentyp = eintragCursor.getString(7);
		}
	   	
		eintragCursor.close();
		myDB.close();
		if(eintrag != null)
		{
			Log.v(tag, "old Eintrag: " + eintrag.day + "." +eintrag.month +"." + eintrag.year +", " + eintrag.wofuer + ", " + eintrag.betrag + ", id=" + eintrag._id + " Listenname: " + listenname);
		    datePicker.updateDate(eintrag.year, eintrag.month-1, eintrag.day);
		    Spinner wofuer = (Spinner)findViewById(R.id.aendern_zweck);
		 	ArrayAdapter myAdap = (ArrayAdapter) wofuer.getAdapter();
		 	int spinnerPosition = myAdap.getPosition(eintrag.wofuer);
		 	wofuer.setSelection(spinnerPosition);
		 	EditText betrag = (EditText)findViewById(R.id.aendern_betrag);
		 	betrag.setText(String.valueOf(eintrag.betrag));
		}
	}
	public void onClickDatum(View v)
    {
    	Button heute = (Button) findViewById(R.id.btn_aendern_Datumheute);
    	Button gestern = (Button) findViewById(R.id.btn_aendern_DatumGestern);
    	
    	TextView gewaehlt = (TextView) findViewById(R.id.txt_aendernGewaehltDatum);
    	
    	if(v == heute)
    	{
    		c = Calendar.getInstance();
    		eintrag.year = c.get(Calendar.YEAR);
    		eintrag.month = c.get(Calendar.MONTH) + 1;
    		eintrag.day = c.get(Calendar.DAY_OF_MONTH);
    		datePicker.updateDate(eintrag.year, eintrag.month -1, eintrag.day);
    	}else if(v == gestern)
    	{
    		c = Calendar.getInstance();
    		c.add(Calendar.DATE, -1);
    		eintrag.year = c.get(Calendar.YEAR);
    		eintrag.month = c.get(Calendar.MONTH) + 1;
    		eintrag.day = c.get(Calendar.DAY_OF_MONTH);
    		datePicker.updateDate(eintrag.year, eintrag.month -1, eintrag.day);
    	}
    	gewaehlt.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year));
    }
	public void onDateChanged(DatePicker view, int year, int monthOfYear,int dayOfMonth) 
    {
    	DatePicker datePicker = (DatePicker) findViewById(R.id.datePicker_aendern);
        eintrag.day = datePicker.getDayOfMonth();
        eintrag.month = datePicker.getMonth()+1;
        eintrag.year = datePicker.getYear();
        // set selected date into textview
     	TextView datum = (TextView) findViewById(R.id.txt_aendernGewaehltDatum);
     	datum.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year));
    }
	public void onClickEintragSpeichern(View view ) 
    {
		Spinner wofuer = (Spinner) findViewById(R.id.aendern_zweck);
    	EditText betrag = (EditText) findViewById(R.id.aendern_betrag);
    	
    	eintrag = null;
    	eintrag = new Eintrag();
    	
    	eintrag.wofuer = wofuer.getSelectedItem().toString();
    	eintrag.betrag = Double.parseDouble(betrag.getText().toString());
    	myDB = null;
    	myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
    	myDB.execSQL("INSERT INTO " + MY_DB_TABLE+" (day, month, year, wofuer, betrag, listenname, listentyp) "
				+"VALUES (" + eintrag.day + "," + eintrag.month+ ","
				+ eintrag.year +", '" + eintrag.wofuer +"' ," + eintrag.betrag +",'" + listenname +"'" + ", '" + tabellentyp +"');");
		myDB.execSQL("DELETE FROM " + MY_DB_TABLE+ " WHERE _id=" + id + ";");
        myDB.close();
		final Intent i = new Intent(this, Tabellenansicht.class);
		i.putExtra(TABELLENNAME, listenname);
		i.putExtra(TABELLENTYP, tabellentyp);
        finish();
        startActivity(i);
    }
}
