package de.micka.lebenshilfe;

import java.util.Calendar;
import android.app.Activity;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.DatePicker.OnDateChangedListener;



public class EintragHinzufuegenActivity extends Activity implements  OnDateChangedListener
{
	private final static String MY_DB_NAME = "HaushaltsbuchDB";
	private static String MY_DB_TABLE = "eintraege";
	public static String TABELLENNAME ="tabellenName";
	public static String TABELLENTYP ="tabellentyp";
	public static String GUTHABEN = "guthaben";
	private final static String tag="ensacom"; 
	private SQLiteDatabase myDB = null;
	private String listenname;
	private String tabellentyp;
	/** Erzeugt Meneintrag beenden **/
    public static final int beenden_ID = Menu.FIRST;
	final Eintrag eintrag = new Eintrag();
	private DatePicker datePicker;
	private Calendar c = Calendar.getInstance();
	 
	public void onCreate(Bundle savedInstanceState) 
	{
        super.onCreate(savedInstanceState);
        setContentView(R.layout.eintraghinzufuegenlayout);
        datePicker = (DatePicker) findViewById(R.id.datePicker);
    	datePicker.init(c.get(Calendar.YEAR),c.get(Calendar.MONTH),c.get(Calendar.DAY_OF_MONTH), this);
    	eintrag.day = c.get(Calendar.DAY_OF_MONTH);
    	eintrag.month = c.get(Calendar.MONTH) + 1;
    	eintrag.year = c.get(Calendar.YEAR);
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
    	menu.add(0, beenden_ID, Menu.NONE, "beenden");
    	return super.onCreateOptionsMenu(menu);
    }
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            Intent i = new Intent(this, Tabellenuebersicht.class);;
            finish();
            startActivity(i);
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
    public boolean onOptionsItemSelected(MenuItem item)
    {//Was passiert wenn ein Meneintrag gewhlt wird
    	switch(item.getItemId())
    	{
    	case beenden_ID: 
    		finish();
    	default:
    		return super.onOptionsItemSelected(item);
    	}
    }
    public void onClickDatum(View v)
    {
    	Button heute = (Button) findViewById(R.id.btnDatumheute);
    	Button gestern = (Button) findViewById(R.id.btnDatumGestern);
    	
    	TextView gewaehlt = (TextView) findViewById(R.id.txtGewaehltDatum);
    	
    	if(v == heute)
    	{
    		c = Calendar.getInstance();
    		eintrag.year = c.get(Calendar.YEAR);
    		eintrag.month = c.get(Calendar.MONTH) + 1;
    		eintrag.day = c.get(Calendar.DAY_OF_MONTH);
    		datePicker.updateDate(eintrag.year, eintrag.month -1, eintrag.day);
    	}else if(v == gestern)
    	{
    		c = Calendar.getInstance();
    		c.add(Calendar.DATE, -1);
    		eintrag.year = c.get(Calendar.YEAR);
    		eintrag.month = c.get(Calendar.MONTH) + 1;
    		eintrag.day = c.get(Calendar.DAY_OF_MONTH);
    		datePicker.updateDate(eintrag.year, eintrag.month -1, eintrag.day);
    	}
    	gewaehlt.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year));
    }
    public void onClickEintragSpeichern(final View sfNormal) 
    {	
    	Spinner wofuer = (Spinner) findViewById(R.id.hinzufuegen_zweck);
    	EditText betrag = (EditText) findViewById(R.id.hinzufuegen_betrag);
    	//Extras abrufen
    	final Bundle extras = this.getIntent().getExtras();
    	if(extras != null)
    	{
    		listenname = extras.getString(Tabellenuebersicht.TABELLENNAME);
    		tabellentyp = extras.getString(Tabellenuebersicht.TABELLENTYP);
    		if(listenname == null)
    		{
    			listenname = extras.getString(Tabellenansicht.TABELLENNAME);
    			tabellentyp = extras.getString(Tabellenansicht.TABELLENTYP);
    		}
    	}
    	eintrag.wofuer = wofuer.getSelectedItem().toString();
    	eintrag.betrag = Double.parseDouble(betrag.getText().toString());
    	myDB = null;
    	myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
    	myDB.execSQL("CREATE TABLE IF NOT EXISTS " + MY_DB_TABLE
				+ " (_id integer primary key autoincrement,"
				+ " day integer(2), month integer(2), year integer(4),"
				+ " wofuer text not null, betrag real, listenname text not null,"
				+ " listentyp text not null);");											
    	myDB.execSQL("INSERT INTO " + MY_DB_TABLE+" (day, month, year, wofuer, betrag, listenname, listentyp) "
				+"VALUES (" + eintrag.day + "," + eintrag.month+ ","
				+ eintrag.year +", '" + eintrag.wofuer +"' ," + eintrag.betrag +",'" + listenname +"'" + ", '" + tabellentyp +"');");
		Log.v(tag, "Insert new Eintrag: " + eintrag.day + "." +eintrag.month +"." + eintrag.year +", " + eintrag.wofuer + ", " + eintrag.betrag + ", id=" + eintrag._id + " in Liste: " + listenname);
        myDB.close();
        final Intent i = new Intent(this, Tabellenansicht.class);
        i.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
        i.putExtra(TABELLENNAME, listenname);
        i.putExtra(TABELLENTYP, tabellentyp);
		//i.putExtra(GUTHABEN, tabellenGuthaben);
		finish();
        startActivity(i);
    }
    public void onDateChanged(DatePicker view, int year, int monthOfYear,int dayOfMonth) 
    {
    	DatePicker datePicker = (DatePicker) findViewById(R.id.datePicker);
        eintrag.day = datePicker.getDayOfMonth();
        eintrag.month = datePicker.getMonth()+1;
        eintrag.year = datePicker.getYear();
        // set selected date into textview
     	TextView datum = (TextView) findViewById(R.id.txtGewaehltDatum);
     	datum.setText("Gewhltes Datum: " + Integer.toString(eintrag.day) + "." + Integer.toString(eintrag.month) + "." + Integer.toString(eintrag.year));
    }
}
