package de.micka.lebenshilfe;

import java.util.ArrayList;
import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.KeyEvent;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

public class Tabellenansicht extends ListActivity
{
	private final static String MY_DB_NAME = "HaushaltsbuchDB";
	private static String MY_DB_TABLE = "eintraege";
	public static String TABELLENNAME ="tabellenName";
	public static String TABELLENTYP ="tabellentyp";
	private double rest;
	private double lebensmittel;
	private double hygiene;
	private double sonstiges;
	private double zigaretten;
	private double suessesEssen;
	private double kino;
	private double schwimmen;
	private double zeitung;
	private double anschaffung;
	public static String ID = "-1";
	private SQLiteDatabase myDB;
	private String listenname = null;
	private String tabellentyp = null;
	private View header;
	private View footer;
	private MenuInflater inflater;
	private ListView listView;
	private AdapterContextMenuInfo info;
	private final static String tag="ensacom"; 
	private EintragListAdapter mAdapter;
    private ArrayList<Eintrag> mData = new ArrayList<Eintrag>();
    private TextView restGuthaben;
    
        
    /** Called when the activity is first created. */
    @Override
	public void onCreate(Bundle savedInstanceState) 
    {
    	super.onCreate(savedInstanceState);
    	extrasAbrufen();
    	initiateData();
    	mAdapter = new EintragListAdapter(this, mData);
    	System.out.println("Vor Footerauswahl tabellentyp= " + tabellentyp);
    	if(tabellentyp == "taschengeld")
    	{
    		footer = getLayoutInflater().inflate(R.layout.ansichttaschengeldfooterlayout, null);
    		restGuthaben = (TextView) findViewById(R.id.eintraegeAnzeigenTaschengeldRestWert);
    		System.out.println("Gewhlt wurde taschengeld");
    	}else if(tabellentyp == "wirtschaftsgeld")
    	{
    		System.out.println("gewhlt wurde haushaltsgeld");
    		footer = getLayoutInflater().inflate(R.layout.ansichtwirtschaftfooterlayout, null);
    		restGuthaben = (TextView) findViewById(R.id.eintraegeAnzeigenHaushaltRestWert);
    	}
    	header = getLayoutInflater().inflate(R.layout.ansichttitellayout, null);
    	listView = getListView();
    	registerForContextMenu(listView);
		listView.addHeaderView(header);
		listView.addFooterView(footer);
		restGuthaben.setText(Double.toString(rest) + "");
		this.setListAdapter(mAdapter);
    }
    public void extrasAbrufen()
    {
    	final Bundle extras = getIntent().getExtras();
    	if(extras != null)
    	{
    		listenname = extras.getString(Tabellenuebersicht.TABELLENNAME);
    		tabellentyp = extras.getString(Tabellenuebersicht.TABELLENTYP);
    		if(listenname == null)
    		{
    			listenname = extras.getString(EintragHinzufuegenActivity.TABELLENNAME);
    			tabellentyp= extras.getString(EintragHinzufuegenActivity.TABELLENTYP);
    			if(listenname == null)
    			{
    				listenname = extras.getString(EintragAendernActivity.TABELLENNAME);
    				tabellentyp = extras.getString(EintragAendernActivity.TABELLENTYP);
    			}
    		}
    	}
    }
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            Intent i = new Intent(this, Tabellenuebersicht.class);;
            finish();
            startActivity(i);
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
    @Override
    public void onCreateContextMenu(ContextMenu menu, View v,
                                    ContextMenuInfo menuInfo) {
      super.onCreateContextMenu(menu, v, menuInfo);
      inflater = getMenuInflater();
      inflater.inflate(R.menu.eintragcontext, menu);
    }
    @Override
    public boolean onContextItemSelected(MenuItem item) 
    {
      info = (AdapterContextMenuInfo) item.getMenuInfo();
      switch (item.getItemId()) {
      case R.id.eintrag_context_bearbeiten:
     	  eintragBearbeiten(info.id);
    	  return true;
      case R.id.eintrag_context_loeschen:
    	  eintragLoeschen(info.id);
          return true;
      default:
        return super.onContextItemSelected(item);
      }
    }
    public void onClickEintragHinzufuegen(View v)
    {
    	Intent intent =  new Intent(this, EintragHinzufuegenActivity.class);
    	intent.putExtra(TABELLENNAME, listenname);
    	intent.putExtra(TABELLENTYP, tabellentyp);
    	//intent.putExtra(GUTHABEN, tabellenGuthaben);
		//intent.putExtra(ID, ID);
    	finish();
		startActivity(intent);
    }
    private void eintragLoeschen(long id)
    {
    	myDB = null;
    	myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
    	try
    	{	
    		myDB.execSQL("DELETE FROM " + MY_DB_TABLE+ " WHERE _id=" + id + ";");
    	}catch(SQLException esql)
    	{
    		Log.v(tag, esql.toString());
    	}
    	myDB.close();
    	final Intent intent = new Intent(this, Tabellenansicht.class);
		intent.putExtra(TABELLENNAME, listenname);
		finish();
		startActivity(intent);
    }
    public void eintragBearbeiten(long id)
    {
    	Intent intent = new Intent(this, EintragAendernActivity.class);
    	intent.putExtra(ID, id);
    	intent.putExtra(TABELLENNAME, listenname);
    	intent.putExtra(TABELLENTYP, tabellentyp);
    	finish();
    	startActivity(intent);
    }
    private void initiateData()
    {
    	rest = 0;
    	lebensmittel = 0;
    	hygiene = 0;
    	sonstiges = 0;
    	zigaretten = 0;
    	suessesEssen = 0;
    	kino = 0;
    	schwimmen = 0;
    	zeitung = 0;
    	anschaffung = 0;
    	myDB = null;
    	final Bundle extras = getIntent().getExtras();
    	if(extras != null)
    	{
    		listenname = extras.getString(Tabellenuebersicht.TABELLENNAME);
    		tabellentyp = extras.getString(Tabellenuebersicht.TABELLENTYP);
    		if(listenname == null)
    		{
    			listenname = extras.getString(EintragHinzufuegenActivity.TABELLENNAME);
    			tabellentyp= extras.getString(EintragHinzufuegenActivity.TABELLENTYP);
    			if(listenname == null)
    			{
    				listenname = extras.getString(EintragHinzufuegenActivity.TABELLENNAME);
    				tabellentyp = extras.getString(EintragHinzufuegenActivity.TABELLENTYP);
    			}
    		}
    	}
    	Eintrag eintrag;
    	myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
    	
   	 	Cursor eintragCursor = myDB.rawQuery("SELECT _id, day, month, year, wofuer, betrag FROM " + MY_DB_TABLE + " WHERE listenname = '" + listenname + "' Order By year, month, day", null);
   	 	
   	 	eintragCursor.moveToFirst();   	 	
   	 	   	 	
   	 	if(eintragCursor.moveToFirst())
   	 	{
   	 		do
   	 		{
   	 			eintrag = null;
   	 			//						id								day						month				year					wofuer					betrag
   	 			eintrag = new Eintrag(eintragCursor.getInt(0),eintragCursor.getInt(1),eintragCursor.getInt(2),eintragCursor.getInt(3),eintragCursor.getString(4),eintragCursor.getDouble(5));
   	 			mData.add(eintrag);
   	 			eintragCursor.moveToNext();
   	 			rest = rest + eintrag.betrag;
   	 			if(eintrag.wofuer ==  "Lebensmittel")
 					lebensmittel = lebensmittel + eintrag.betrag;
   	 			else if(eintrag.wofuer == "Zigaretten")
   	 				zigaretten = zigaretten + eintrag.betrag;
   	 			else if(eintrag.wofuer == "Hygiene")
 					hygiene = hygiene + eintrag.betrag;
   	 			else if(eintrag.wofuer == "Sonstiges")
 					sonstiges = sonstiges + eintrag.betrag;
   	 			else if(eintrag.wofuer == "Ses/Essen")
   	 				suessesEssen = suessesEssen + eintrag.betrag;
   	 			else if(eintrag.wofuer == "Kino")
	 				kino = kino + eintrag.betrag;
   	 			else if(eintrag.wofuer == "Schwimmen")
   	 				schwimmen = schwimmen + eintrag.betrag;
   	 			else if(eintrag.wofuer == "Zeitung")
   	 				zeitung = zeitung + eintrag.betrag;
   	 			else if(eintrag.wofuer == "Anschaffung")
   	 				anschaffung = anschaffung + eintrag.betrag;
   	 		}while(eintragCursor.isAfterLast() == false);	
   	 	}
   	 	eintragCursor.close();
   	 	myDB.close();
   	 	if(tabellentyp == "taschengeld")
   	 	{
   	 		EditText txtZigaretten = (EditText) findViewById(R.id.eintraegeAnzeigenZigarettenWert);
   	 		txtZigaretten.setText(Double.toString(zigaretten) + "");
   	 		EditText txtSuessesEssen = (EditText) findViewById(R.id.eintraegeAnzeigenSuessesEssenWert);
   	 		txtSuessesEssen.setText(Double.toString(suessesEssen) + "");
   	 		EditText txtKino = (EditText) findViewById(R.id.eintraegeAnzeigenKinoWert);
	 		txtKino.setText(Double.toString(kino) + "");
   	 		EditText txtSchwimmen = (EditText) findViewById(R.id.eintraegeAnzeigenSchwimmenWert);
   	 		txtSchwimmen.setText(Double.toString(schwimmen) + "");
   	 		EditText txtZeitung = (EditText) findViewById(R.id.eintraegeAnzeigenZeitungWert);
	 		txtZeitung.setText(Double.toString(zeitung) + "");
	 		EditText txtAnschaffung = (EditText) findViewById(R.id.eintraegeAnzeigenSchwimmenWert);
   	 		txtAnschaffung.setText(Double.toString(anschaffung) + "");
   	 		EditText txtRest = (EditText) findViewById(R.id.eintraegeAnzeigenTaschengeldRestWert);
	 		txtRest.setText(Double.toString(rest) + "");
   	 	}else if(tabellentyp == "wirtschaftsgeld")
   	 	{
   	 		EditText txtLebensmittel = (EditText) findViewById(R.id.eintraegeAnzeigenLebensmittelWert);
	 		txtLebensmittel.setText(Double.toString(lebensmittel) + "");
	 		EditText txtHygiene = (EditText) findViewById(R.id.eintraegeAnzeigenHygieneWert);
   	 		txtHygiene.setText(Double.toString(hygiene) + "");
   	 		EditText txtSonstiges = (EditText) findViewById(R.id.eintraegeAnzeigenSonstigesWert);
	 		txtSonstiges.setText(Double.toString(sonstiges) + "");
	 		EditText txtRest = (EditText) findViewById(R.id.eintraegeAnzeigenHaushaltRestWert);
   	 		txtRest.setText(Double.toString(rest) + "");
   	 	}
    }
}
