package de.micka.lebenshilfe;


import java.util.ArrayList;
import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.AdapterView.AdapterContextMenuInfo;

public class Tabellenuebersicht extends ListActivity {
    
	private final static String MY_DB_NAME = "HaushaltsbuchDB";
	private static String MY_DB_TABLE = "eintraege";
	private final static String tag="ensacom";
	public static String TABELLENNAME ="tabellenName";
	public static String TABELLENTYP = "tabellentyp";
	public static final String ID = "id";
	private String listenname;
	private String tabellentyp;
	private SQLiteDatabase myDB = null;
	private Tabelle tabelle = null;
	private View header = null;
	private ListView listView = null;
	private TabelleListAdapter mAdapter;
    private ArrayList<Tabelle> mData = new ArrayList<Tabelle>();
    private Cursor tabelleCursor = null;
    private Cursor tabelleCursor2 = null;
    private MenuInflater inflater;
    private AdapterContextMenuInfo info;
    private TextView txtview = null;
    private EditText newTable = null;
	
	/** Called when the activity is first created. */
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        initiateDatabase(); //Datenbank initialisieren
    	initiateData();		//Array-List fr Listview fllen
    	mAdapter = new TabelleListAdapter(this, mData);
    	header = getLayoutInflater().inflate(R.layout.uebersichttitellayout, null);
    	listView = getListView();
    	registerForContextMenu(listView);
		listView.addHeaderView(header);
    	this.setListAdapter(mAdapter);
    }
    private void tabelleLoeschen(long id)
    {
    	myDB = null;
    	myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
    	try
    	{	
    		tabelleCursor = myDB.rawQuery("SELECT listenname FROM " + MY_DB_TABLE + " WHERE _id=" + id , null);
    	}catch(SQLException esql)
    	{
    		Log.v(tag, esql.toString());
    	}
    	tabelleCursor.moveToFirst();
    	listenname = tabelleCursor.getString(0);
    	tabelleCursor.close();
    	myDB.execSQL("DELETE FROM " + MY_DB_TABLE+ " WHERE listenname = '" + listenname + "';");
    	myDB.close();
    	final Intent intent = new Intent(this, Tabellenuebersicht.class);
		finish();
		startActivity(intent);
    }
    public void tabelleBearbeiten(long tabid)
    {
    	myDB = null;
    	myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
    	
   	 	tabelleCursor = myDB.rawQuery("SELECT listenname, tabellentyp FROM "+ MY_DB_TABLE + " WHERE _id = " + tabid , null);
   	 	tabelleCursor.moveToFirst();
   	 	listenname = tabelleCursor.getString(0);
   	 	tabellentyp = tabelleCursor.getString(1);
   	 	tabelleCursor.close();
   	 	myDB.close();
   	 	final Intent intent = new Intent(this, TabelleBearbeitenActivity.class);
   	 	intent.putExtra(TABELLENNAME, listenname);
   	 	intent.putExtra(TABELLENTYP, tabellentyp);
   	 	//intent.putExtra(ID, this.id);
   	 	finish();
		startActivity(intent);
    }
    public void onCreateContextMenu(ContextMenu menu, View v,ContextMenuInfo menuInfo) 
    {
    	super.onCreateContextMenu(menu, v, menuInfo);
    	inflater = getMenuInflater();
    	inflater.inflate(R.menu.tabellecontext, menu);
    }
    public boolean onContextItemSelected(MenuItem item) 
    {
      info = (AdapterContextMenuInfo) item.getMenuInfo();
      switch (item.getItemId()) {
      case R.id.tabelle_context_bearbeiten:
    	  tabelleBearbeiten(info.id);
     	  //Log.v(tag, mData.get(info.position-1).tabellenname);
    	  return true;
      case R.id.tabelle_context_loeschen:
    	  tabelleLoeschen(info.id);
          return true;
      default:
        return super.onContextItemSelected(item);
      }
    }    
    private void initiateDatabase()
    {
    	//initialisieren der eintragsTabelle
    	myDB = null; 
    	try {
    		myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
    		myDB.execSQL("CREATE TABLE IF NOT EXISTS " + MY_DB_TABLE
    				+ " (_id integer primary key autoincrement,"
    				+ " day integer(2), month integer(2), year integer(4),"
    				+ " wofuer text not null, betrag real, listenname text not null,"
    				+ " listentyp text not null);");	
        } finally {
             if (myDB != null)
                  myDB.close();
        }
    }
    private void initiateData()
    {
    	myDB = null;
    	myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
    	
   	 	tabelleCursor = myDB.rawQuery("SELECT DISTINCT listenname FROM "+ MY_DB_TABLE + " Order By listenname", null);
   	 	
   	 	tabelleCursor.moveToFirst();   	 	
   	 	
   	 	
   	 	if(tabelleCursor.moveToFirst())
   	 	{
   	 		do
   	 		{
   	 			tabelleCursor2 = null;
   	 			tabelleCursor2 = myDB.rawQuery("SELECT _id FROM "+ MY_DB_TABLE + " WHERE listenname = '" + tabelleCursor.getString(0) +"'", null);
   	 			tabelle = null;
   	 			tabelleCursor2.moveToFirst();
   	 			tabelle = new Tabelle(tabelleCursor2.getInt(0),tabelleCursor.getString(0));
   	 			tabelleCursor2.close();
   	 			mData.add(tabelle);
   	 			tabelleCursor.moveToNext();
   	 		}while(tabelleCursor.isAfterLast() == false);
   	 	}
   	 	tabelleCursor.close();
   	 	myDB.close();
    }
    public void onClickTabelleAnzeigen(View view)
    {
    	txtview = (TextView) view;
    	//Neue Activity
    	final Intent intent = new Intent(this, Tabellenansicht.class);
    	
    	//zu bergebene Werte setzen
		listenname = (String) txtview.getText();
		myDB = null;
    	myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
    	
    	tabelleCursor = myDB.rawQuery("SELECT listentyp FROM "+ MY_DB_TABLE + " WHERE listenname = '" + listenname +"'", null);
    	tabelleCursor.moveToFirst();
    	tabellentyp = tabelleCursor.getString(0);
				
		//Extras bergeben
		intent.putExtra(TABELLENNAME, listenname);
		intent.putExtra(TABELLENTYP, tabellentyp);
		finish();
		startActivity(intent);
    }
    public void onClickTabelleHinzufuegen(View view)
    {
    	newTable = null;
    	newTable = (EditText) findViewById(R.id.edt_liste_name);
    	/*try {
    		myDB = this.openOrCreateDatabase(MY_DB_NAME, MODE_PRIVATE, null);
    		myDB.execSQL("CREATE TABLE IF NOT EXISTS " + MY_DB_TABLE
    				+ " (_id integer primary key autoincrement,"
    				+ " day integer(2), dayid integer, month integer(2), monthid integer,"
    				+ " year integer(4), yearid integer, wofuer text not null,"
    				+ " betrag real, listenname text not null)"
    				+";");
        } finally {
             if (myDB != null)
                  myDB.close();
        }*/
    	final Intent intent = new Intent(this, EintragHinzufuegenActivity.class);
    	listenname = newTable.getText().toString();
    	RadioGroup radioGroup = (RadioGroup) findViewById(R.id.radiogroup_tabellentyp);
    	int checkedRadioButton = radioGroup.getCheckedRadioButtonId();
    	tabellentyp = "bla";
    	
    	switch (checkedRadioButton) 
    	{
    	  case R.id.radioButtonTaschengeld : tabellentyp = "taschengeld";
    	                   	              break;
    	  case R.id.radioButtonWirtschaft : tabellentyp = "wirtschaftsgeld";
    			                      break;
    	}
    	intent.putExtra(TABELLENNAME, listenname);
    	intent.putExtra(TABELLENTYP, tabellentyp);
    	finish();
    	startActivity(intent);
    }
}